open Graphics;;

let a = 1.4 and b = 0.3 ;;
let n = 1000 ;;
	
open_graph " 1600x800" ;;

let res_x = float_of_int (size_x()) ;;
let res_y = float_of_int (size_y()) ;;
let y1 = 0. and y2 = 1. and x1 = 2.8 and x2 = 4. ;;

let plot_reel x y = 
	let change_res_x a = int_of_float (res_x *. (a -. x1) /. (x2 -. x1)) in
	let change_res_y a = int_of_float (res_y *. (a -. y1) /. (y2 -. y1)) in
	plot (change_res_x x) (change_res_y y)
	;;

let rec attract_henon u v i =
	let x = v +. 1. -. a*.u*.u in
	let y = b *. u in
	plot_reel x y ;
	print_float x ; print_float y ; print_newline() ;
	if i > 1 then attract_henon x y (i-1) else ()
	;;
	
let rec f g m x i =
	let y = m *. g x in
	plot_reel m y ;
	if i > 1 then f g m y (i-1) else y
	;;
	
let rec freigenbaum g mu x =
	let y = f g mu x n in
	if mu < x2 then freigenbaum g (mu +. (x2 -. x1) /. res_x) y else ()
	;;

(*attract_henon 0. 0. n ;;*)
freigenbaum (fun x -> x *. ( 1. -. x)) x1 0.5 ;;
read_line()
	
	
